//+------------------------------------------------------------------+
//|                                                     LSMA nrp.mq4 |
//|                                                           mladen |
//+------------------------------------------------------------------+
#property  copyright "copyleft mladen"
#property  link      "mladenfx@gmail.com"

#property indicator_chart_window
#property indicator_buffers 5
#property indicator_color1 White
#property indicator_color2 Blue
#property indicator_color3 Blue
#property indicator_color4 Red
#property indicator_color5 Red
#property indicator_width1 2
#property indicator_width2 2
#property indicator_width3 2
#property indicator_width4 2
#property indicator_width5 2


extern int    LSMAPeriod   = 24;
extern int    LSMAPrice    =  0;
extern bool   AlertOn      = false;

double lsma_0[];
double lsma_1[];
double lsma_2[];
double lsma_3[];
double lsma_4[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

int init()
{
   SetIndexBuffer(0,lsma_0);
   SetIndexBuffer(1,lsma_1);
   SetIndexBuffer(2,lsma_2);
   SetIndexBuffer(3,lsma_3);
   SetIndexBuffer(4,lsma_4);
   return(0);
}

int start()
{ 
   int      counted_bars=IndicatorCounted();
   int      limit,i;

   if(counted_bars < 0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);

   //if (lsma_0[limit] > lsma_0[limit+1]) CleanPoint(limit,lsma_1,lsma_2);
   //if (lsma_0[limit] < lsma_0[limit+1]) CleanPoint(limit,lsma_3,lsma_4);
   for(i = limit; i >= 0; i--)
   {
      lsma_0[i]   = 3.0*iMA(NULL,0,LSMAPeriod,0,MODE_LWMA,LSMAPrice,i)-2.0*iMA(NULL,0,LSMAPeriod,0,MODE_SMA,LSMAPrice,i);
      lsma_1[i] = EMPTY_VALUE;
      lsma_2[i] = EMPTY_VALUE;
      lsma_3[i] = EMPTY_VALUE;
      lsma_4[i] = EMPTY_VALUE;
         if (lsma_0[i] > lsma_0[i+1]) PlotPoint(i,lsma_1,lsma_2,lsma_0);
         if (lsma_0[i] < lsma_0[i+1]) PlotPoint(i,lsma_3,lsma_4,lsma_0);
   }   
  //------------------------------------------------------------------------ 
  // Alerts on color change
  // added by wiedstone, taken from codersguru - www.forex-tsd.com

   static string last_clr = "";
   string current_clr;
   static bool first_time = false;
        
   if (first_time)
    {
     if (lsma_0[0]  > lsma_0[1])
       current_clr="Blue";
     if (lsma_0[0]  < lsma_0[1])
       current_clr="Red";
        
     if(last_clr != current_clr) //changed 
     {
      last_clr = current_clr;
      if(AlertOn) 
      { AlertOnce("changed : current color is " + current_clr,1);
      }
     }
    }
    else
    {
     first_time = true;
    } 
   //-----------------------------------------------------------------------  
   return(0);
}
//+-------------------------------------------------------------------------
void CleanPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

void PlotPoint(int i,double& first[],double& second[],double& price[])
{
   if (first[i+1] == EMPTY_VALUE)
      {
         if (first[i+2] == EMPTY_VALUE) {
                first[i]   = price[i];
                first[i+1] = price[i+1];
                second[i]  = EMPTY_VALUE;
            }
         else {
                second[i]   =  price[i];
                second[i+1] =  price[i+1];
                first[i]    = EMPTY_VALUE;
            }
      }
   else
      {
         first[i]   = price[i];
         second[i]  = EMPTY_VALUE;
      }
}
bool AlertOnce(string alert_msg, int ref)
{  
   static int LastAlert = 0;
   if( LastAlert== 0 || LastAlert< Bars )
     {
      Alert(alert_msg);
      LastAlert= Bars;
      return (1);
     }
}